/*
 *  H8 Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

/*
 *	H8 Serial Functions
 */

#if TARGET_CPU == 3048

#include "3048.h"

#endif	/* of #ifdef TARGET_CPU == 3048 */

#if TARGET_CPU == 3052

#include "3052.h"

#endif	/* of #ifdef TARGET_CPU == 3052 */

#if TARGET_CPU == 3068

#include "3068.h"

#endif	/* of #ifdef TARGET_CPU == 3068 */

#if TARGET_CPU == 3069

#include "3069.h"

#endif	/* of #ifdef TARGET_CPU == 3069 */

#include "serial.h"

		.h8300h

		.text
		.align		2

/*
 *	Initialize Serial Channel
 *
 *		Input:	er3: Serial Channel #
 */

_InitSerial:
		mov.l		er3, er2
		mov.b		r3h, @(SCIRXBuffCount, er2)
		mov.b		r3h, @(SCITXBuffCount, er2)
		mov.b		r3h, @(SCIRXFlowCntrl, er2)
		mov.b		r3h, @(SCITXFlowCntrl, er2)
		mov.b		r3h, @(SCIRXXOFF,      er2)

		mov.l		er3, er1
		shll.l		er1
		shll.l		er1

		mov.w		#DEF_SCIRX_BUFF_SIZE, r0
		mulxu.w		r0, er2
		add.l		#SCIRXBuffer, er2

		mov.l		er2, @(SCIRXBuffBase,  er1)
		mov.l		er2, @(SCIRXReadPtr,   er1)
		mov.l		er2, @(SCIRXWritePtr,  er1)

		add.l		#DEF_SCIRX_BUFF_SIZE, er2
		mov.l		er2, @(SCIRXBuffLimit, er1)

		mov.l		er3, er2
		mov.w		#DEF_SCITX_BUFF_SIZE, r0
		mulxu.w		r0, er2
		add.l		#SCITXBuffer, er2

		mov.l		er2, @(SCITXBuffBase,  er1)
		mov.l		er2, @(SCITXReadPtr,   er1)
		mov.l		er2, @(SCITXWritePtr,  er1)

		add.l		#DEF_SCITX_BUFF_SIZE, er2
		mov.l		er2, @(SCITXBuffLimit, er1)

		shll.l		er1

		mov.b		#0, r2l						/* Initialize SCR, SMR and BRR */
		mov.b		r2l, @(IOREG_SCI_BASE + IOREG_SCR_OFFSET, er1)
		mov.b		#DEFAULT_SMR, r2l
		mov.b		r2l, @(IOREG_SCI_BASE + IOREG_SMR_OFFSET, er1)
		mov.b		#DEFAULT_BRR, r2l
		mov.b		r2l, @(IOREG_SCI_BASE + IOREG_BRR_OFFSET, er1)

		mov.w		#CLOCK_RATE / DEFAULT_SPEED + 1, r0		/* Wait for 1 bit */

InitSerial1:
		dec.w		#1, r0
		bne		InitSerial1

		mov.b		#SCR_RIE | SCR_TE | SCR_RE, r2l
		mov.b		r2l, @(IOREG_SCI_BASE + IOREG_SCR_OFFSET, er1)
		mov.b		@(IOREG_SCI_BASE + IOREG_SSR_OFFSET, er1), r2l	/* Dummy read */
		mov.b		#SSR_TDRE, r2l
		mov.b		r2l, @(IOREG_SCI_BASE + IOREG_SSR_OFFSET, er1)	/* Clear error flags */

		rts

/*
 *	Send Character
 *
 *		Input:	r3l: Serial Channel #
 *			r3h: Character sent
 */

_SendChar:
		push.l		er4

		sub.l		er1, er1
		mov.b		r3l, r1l
		mov.l		er1, er2

SendChar1:
		mov.b		@(SCITXBuffCount, er1), r0l
		cmp.b		#DEF_SCITX_BUFF_SIZE, r0l
		bhs		SendChar1

		shll.l		er1
		shll.l		er1
		mov.l		@(SCITXWritePtr, er1), er0
		mov.b		r3h, @er0
		inc.l		#1, er0
		mov.l		@(SCITXBuffLimit, er1), er4
		cmp.l		er4, er0
		blo		SendChar2

		mov.l		@(SCITXBuffBase, er1), er0

SendChar2:
		mov.l		er0, @(SCITXWritePtr, er1)

		orc.b		#CCR_INTERRUPT, ccr		/* disable interrupt on CCR */
		mov.b		@(SCITXBuffCount, er2), r0l
		inc.b		r0l
		mov.b		r0l, @(SCITXBuffCount, er2)
		andc.b		#~CCR_INTERRUPT, ccr		/* enable interrupt on CCR */

		mov.b		@(SCITXFlowCntrl, er2), r0l
		bne		SendChar3

		shll.l		er1
		mov.b		@(IOREG_SCI_BASE + IOREG_SCR_OFFSET, er1), r0l
		or.b		#SCR_TIE, r0l
		mov.b		r0l, @(IOREG_SCI_BASE + IOREG_SCR_OFFSET, er1)

SendChar3:
		pop.l		er4
		rts

/*
 *	SCI Common Intrrupt Handler: Recive Data Full
 *
 *		Input:	er3: Serial Channel #
 */

ComInterRX:
		push.l		er0
		push.l		er1
		push.l		er2

		mov.l		er3, er1
		shll.l		er1
		shll.l		er1
		shll.l		er1
ComInterRX1:
		mov.b		@(IOREG_SCI_BASE + IOREG_SSR_OFFSET, er1), r2l
		mov.b		r2l, r2h
		and.b		#SSR_OPER | SSR_FER | SSR_PER, r2l
		beq		ComInterRX2
		and		#~(SSR_OPER | SSR_FER | SSR_PER), r2h
		mov.b		r2h, @(IOREG_SCI_BASE + IOREG_SSR_OFFSET, er1)
ComInterRX2:
		mov.b		r2h, r2l
		and.b		#SSR_RDRF, r2h
		beq		ComInterRX7:16
		mov.b		@(IOREG_SCI_BASE + IOREG_RDR_OFFSET, er1), r0l
		and.b		#~SSR_RDRF, r2l
		mov.b		r2l, @(IOREG_SCI_BASE + IOREG_SSR_OFFSET, er1)
		mov.b		r0l, r0h
		cmp.b		#'S'-'@', r0h
		beq		ComInterRX3
		add.b		#'@'-'Q', r0h			/* sub.b #'Q'-'@', r0h */
		bne		ComInterRX4
ComInterRX3:
		mov.b		r0h, @(SCITXFlowCntrl, er3)
		bne		ComInterRX7
		bra		ComInterRX6
ComInterRX4:
		shlr.l		er1
		mov.l		@(SCIRXWritePtr, er1), er2
		mov.b		r0l, @er2
		inc.l		#1, er2
		mov.l		@(SCIRXBuffLimit, er1), er0
		cmp.l		er0, er2
		blo		ComInterRX5

		mov.l		@(SCIRXBuffBase, er1), er2
ComInterRX5:
		mov.l		er2, @(SCIRXWritePtr, er1)

		mov.b		@(SCIRXBuffCount, er3), r2l
		cmp.b		#DEF_SCIRX_BUFF_SIZE, r2l
		bhs		ComInterRX7

		inc.b		r2l
		mov.b		r2l, @(SCIRXBuffCount, er3)
		cmp.b		#SCI_HIGH_WMARK, r2l		/* check high water mark */
		blo		ComInterRX7

		mov.b		@(SCIRXFlowCntrl, er3), r2h	/* check XOFF sent */
		bne		ComInterRX7

		mov.b		#'S'-'@', r2h
		mov.b		r2h, @(SCIRXFlowCntrl, er3)	/* set flow control */
		mov.b		r2h, @(SCIRXXOFF, er3)		/* set XOFF character */
		shll.l		er1
ComInterRX6:
		mov.b		@(IOREG_SCI_BASE + IOREG_SCR_OFFSET, er1), r0h
		or.b		#SCR_TIE, r0h
		mov.b		r0h, @(IOREG_SCI_BASE + IOREG_SCR_OFFSET, er1)
ComInterRX7:
		pop		er2
		pop		er1
		pop		er0
		rts

/*
 *	SCI Common Intrrupt Handler: Transmit Data Empty
 *
 *		Input:	er3: Serial Channel #
 */

ComInterTX:
		push.l		er0
		push.l		er1
		push.l		er2

		mov.l		er3, er1
		shll.l		er1
		shll.l		er1

		mov.b		@(SCIRXXOFF, er3), r0l
		beq		ComInterTX0

		mov.b		r3h, @(SCIRXXOFF, er3)		/* r3h == 00 */
		mov.b		r3h, r0h
		mov.b		r0l, r3h
		bra		ComInterTX2
ComInterTX0:
		mov.b		@(SCITXBuffCount, er3), r0l
		beq		ComInterTX3

		mov.l		@(SCITXReadPtr, er1), er2
		mov.b		@er2+, r3h
		mov.l		@(SCITXBuffLimit, er1), er0
		cmp.l		er0, er2
		blo		ComInterTX1

		mov.l		@(SCITXBuffBase, er1), er2
ComInterTX1:
		mov.l		er2, @(SCITXReadPtr, er1)
		mov.b		#1, r0h
ComInterTX2:
		shll.l		er1
		mov.b		r3h, @(IOREG_SCI_BASE + IOREG_TDR_OFFSET, er1)
		mov.b		@(IOREG_SCI_BASE + IOREG_SSR_OFFSET, er1), r0l
		and.b		#~SSR_TDRE, r0l
		mov.b		r0l, @(IOREG_SCI_BASE + IOREG_SSR_OFFSET, er1)

		sub.b		r3h, r3h
		mov.b		@(SCITXBuffCount, er3), r0l
		sub.b		r0h, r0l
		mov.b		r0l, @(SCITXBuffCount, er3)
		beq		ComInterTX3

		mov.b		@(SCITXFlowCntrl, er3), r0l
		beq		ComInterTX4
ComInterTX3:
		mov.b		@(IOREG_SCI_BASE + IOREG_SCR_OFFSET, er1), r0h
		and.b		#~SCR_TIE, r0h
		mov.b		r0h, @(IOREG_SCI_BASE + IOREG_SCR_OFFSET, er1)
ComInterTX4:
		pop.l		er2
		pop.l		er1
		pop.l		er0
		rts

/*
 *	SCI Intrrupt Handler: SCI #0, Error
 */

_InterERI0:
		rte

/*
 *	SCI Intrrupt Handler: SCI #0, Recive Data Full
 */

_InterRXI0:
		push.l		er3
		sub.l		er3, er3
		bsr		ComInterRX:16
		pop.l		er3
		rte

/*
 *	SCI Intrrupt Handler: SCI #0, Transmit Data Empty
 */

_InterTXI0:
		push.l		er3
		sub.l		er3, er3
		bsr		ComInterTX:16
		pop.l		er3
		rte

/*
 *	SCI Intrrupt Handler: SCI #0, Transmit Data End
 */

_InterTEI0:
		rte

#if MAX_SERIAL >= 2

/*
 *	SCI Intrrupt Handler: SCI #1, Error
 */

_InterERI1:
		rte

/*
 *	SCI Intrrupt Handler: SCI #1, Recive Data Full
 */

_InterRXI1:
		push.l		er3
		sub.l		er3, er3
		inc.l		#1, er3
		bsr		ComInterRX:16
		pop.l		er3
		rte

/*
 *	SCI Intrrupt Handler: SCI #1, Transmit Data Empty
 */

_InterTXI1:
		push.l		er3
		sub.l		er3, er3
		inc.l		#1, er3
		bsr		ComInterTX:16
		pop.l		er3
		rte

/*
 *	SCI Intrrupt Handler: SCI #1, Transmit Data End
 */

_InterTEI1:
		rte

#endif	/* of #if MAX_SERIAL >= 2 */

#if MAX_SERIAL >= 3

/*
 *	SCI Intrrupt Handler: SCI #2, Error
 */

_InterERI2:
		rte

/*
 *	SCI Intrrupt Handler: SCI #2, Recive Data Full
 */

_InterRXI2:
		push.l		er3
		sub.l		er3, er3
		inc.l		#2, er3
		bsr		ComInterRX:16
		pop.l		er3
		rte

/*
 *	SCI Intrrupt Handler: SCI #2, Transmit Data Empty
 */

_InterTXI2:
		push.l		er3
		sub.l		er3, er3
		inc.l		#2, er3
		bsr		ComInterTX:16
		pop.l		er3
		rte

/*
 *	SCI Intrrupt Handler: SCI #2, Transmit Data End
 */

_InterTEI2:
		rte

#endif	/* of #if MAX_SERIAL >= 3 */

/*
 *	Recive Character
 *
 *		Input:	r3l: Serial Channel #
 *		Output:	r0l: Character received, 0 if no data
 */

_ReciveChar:
		sub.l		er2, er2
		mov.b		r3l, r2l
		mov.b		@(SCIRXBuffCount, er2), r0l
		beq		ReciveChar4:16

		orc.b		#CCR_INTERRUPT, ccr		/* disable interrupt on CCR */
		mov.b		@(SCIRXBuffCount, er2), r0l
		dec.b		r0l
		mov.b		r0l, @(SCIRXBuffCount, er2)
		andc.b		#~CCR_INTERRUPT, ccr		/* enable interrupt on CCR */

		cmp.b		#SCI_LOW_WMARK, r0l		/* check low water mark */
		bhs		ReciveChar2

		mov.b		@(SCIRXFlowCntrl, er2), r0h	/* check XOFF sent */
		beq		ReciveChar2

		mov.b		r2h, @(SCIRXFlowCntrl, er2)	/* clear flow control, r2h == 00 */
		mov.l		er2, er1
		shll.l		er1
		shll.l		er1
		shll.l		er1
		mov.b		#'Q'-'@', r0h
		orc.b		#CCR_INTERRUPT, ccr		/* disable interrupt on CCR */
		mov.b		r0h, @(SCIRXXOFF, er2)
		mov.b		@(IOREG_SCI_BASE + IOREG_SCR_OFFSET, er1), r0h
		or.b		#SCR_TIE, r0h
		mov.b		r0h, @(IOREG_SCI_BASE + IOREG_SCR_OFFSET, er1)
		andc.b		#~CCR_INTERRUPT, ccr		/* enable interrupt on CCR */
ReciveChar2:
		shll.l		er2
		shll.l		er2
		mov.l		@(SCIRXReadPtr, er2), er1
		mov.b		@er1, r0l
		push.w		r0
		inc.l		#1, er1
		mov.l		@(SCIRXBuffLimit, er2), er0
		cmp.l		er0, er1
		blo		ReciveChar3

		mov.l		@(SCIRXBuffBase, er2), er1
ReciveChar3:
		mov.l		er1, @(SCIRXReadPtr, er2)
		pop.w		r0
ReciveChar4:
		rts

/*
 *	Seiral Data
 */

		.bss
		.align		4

SCIRXWritePtr:	.space		4 * MAX_SERIAL
SCIRXReadPtr:	.space		4 * MAX_SERIAL
SCIRXBuffBase:	.space		4 * MAX_SERIAL
SCIRXBuffLimit:	.space		4 * MAX_SERIAL
SCITXWritePtr:	.space		4 * MAX_SERIAL
SCITXReadPtr:	.space		4 * MAX_SERIAL
SCITXBuffBase:	.space		4 * MAX_SERIAL
SCITXBuffLimit:	.space		4 * MAX_SERIAL

		.align		4

SCIRXBuffer:	.space		DEF_SCIRX_BUFF_SIZE * MAX_SERIAL
SCITXBuffer:	.space		DEF_SCITX_BUFF_SIZE * MAX_SERIAL
SCIRXBuffCount:	.space		MAX_SERIAL
SCITXBuffCount:	.space		MAX_SERIAL
SCIRXFlowCntrl:	.space		MAX_SERIAL
SCITXFlowCntrl:	.space		MAX_SERIAL
SCIRXXOFF:	.space		MAX_SERIAL

		.align		4

		.end
